/* devAsynInt64Array.c */
/***********************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of
* California, as Operator of Los Alamos National Laboratory, and
* Berliner Elektronenspeicherring-Gesellschaft m.b.H. (BESSY).
* asynDriver is distributed subject to a Software License Agreement
* found in file LICENSE that is included with this distribution.
***********************************************************************/
/*
    Mark Rivers
    March 26, 2008
*/

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>

#include <alarm.h>
#include <recGbl.h>
#include <dbAccess.h>
#include <callback.h>
#include <dbDefs.h>
#include <dbStaticLib.h>
#include <link.h>
#include <errlog.h>
#include <epicsMutex.h>
#include <cantProceed.h>
#include <dbCommon.h>
#include <dbScan.h>
#include <waveformRecord.h>
#include <recSup.h>
#include <devSup.h>
#include <menuFtype.h>

#include <epicsExport.h>
#include "asynDriver.h"
#include "asynDrvUser.h"
#include "asynInt64Array.h"
#include "asynEpicsUtils.h"

#include "devAsynXXXArray.h"

/* The code for this driver is generated by the macro in the include file with macro substitution */

ASYN_XXX_ARRAY_FUNCS("devAsynInt64Array", asynInt64Array, asynInt64ArrayType,
                     interruptCallbackInt64Array, epicsInt64, asynInt64ArrayWfIn, asynInt64ArrayWfOut,
                     menuFtypeINT64, menuFtypeUINT64)

